import javax.swing.JOptionPane;
import javax.swing.JDialog;
import javax.swing.JButton;
import javax.swing.JRadioButton;
import javax.swing.ButtonGroup;
import javax.swing.JLabel;
import javax.swing.ImageIcon;
import javax.swing.BoxLayout;
import javax.swing.BorderFactory;
import javax.swing.border.Border;
import javax.swing.JTabbedPane;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.*;
import java.beans.*; //Property change stuff
import java.awt.*;
import java.awt.event.*;

public class DialogDemo extends JPanel implements ActionListener{
  JLabel label;
  FinalBE fbe;
    ImageIcon icon = new ImageIcon("images/openmind_small.gif");
    JFrame frame;
    String simpleDialogDesc = "Teach Open Mind!  When is this sentence true?";
    String moreDialogDesc = "Teach Open Mind!  This sentence is true IF...";
    String iconDesc = "Teach Open Mind!  You decide how to modify the sentence to make it true!";
    CustomDialog customDialog;
  String emptyString=new String("");
  String sentence;
    public DialogDemo(JFrame frame, int tabbedPaneInt, String sentence1, FinalBE fbe2) {
      sentence=sentence1;
      this.frame = frame;
        customDialog = new CustomDialog(frame, "geisel", this);
        customDialog.pack();
	fbe=fbe2;
        //create the components
        JPanel frequentPanel = createSimpleDialogBox();
        JPanel featurePanel = createFeatureDialogBox();
        JPanel iconPanel = createIconDialogBox();
        label = new JLabel("Please make the necessary changes to the sentence to teach Open Mind the proper context for the Common Sense Knowledge!",
                           JLabel.CENTER);

        //lay them out
        Border padding = BorderFactory.createEmptyBorder(20,20,5,20);
        frequentPanel.setBorder(padding);
        featurePanel.setBorder(padding);
        iconPanel.setBorder(padding);

        JTabbedPane tabbedPane = new JTabbedPane();
        tabbedPane.addTab("When...", null, 
                          frequentPanel,
                          simpleDialogDesc); //tooltip text
        tabbedPane.addTab("If...", null, 
                          featurePanel,
                          moreDialogDesc); //tooltip text
        tabbedPane.addTab("Other...", null, 
                          iconPanel,
                          iconDesc); //tooltip text
	tabbedPane.setSelectedIndex(tabbedPaneInt);
        setLayout(new BorderLayout());
        add(tabbedPane, BorderLayout.CENTER);
        add(label, BorderLayout.SOUTH);
        label.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
    }

    void setLabel(String newText) {
        label.setText(newText);
    }

  private JPanel createSimpleDialogBox() {
    final JTextField textField=new JTextField(15);
    JLabel textFieldLabel = new JLabel("When");
    textFieldLabel.setLabelFor(textField);
    JLabel textFieldLabel2=new JLabel(sentence);
    
    JPanel textFieldPane=new JPanel();
    textFieldPane.setLayout(new FlowLayout());
    textFieldPane.add(textFieldLabel);
    textFieldPane.add(textField);
    textFieldPane.add(textFieldLabel2);
    JButton showItButton = new JButton("Teach Open Mind!");
    
    
     System.out.println(textField.getText());
     
     showItButton.addActionListener(new ActionListener() {
	 public void actionPerformed(ActionEvent e) {
	   final String sentenceNew3=textField.getText();
	   if ((sentenceNew3==null)||emptyString.equals(sentenceNew3)){
	     JOptionPane.showMessageDialog(DialogDemo.this, "Please teach something new to Open Mind","error",
					   JOptionPane.ERROR_MESSAGE);
	   }
	  
	   else  fbe.storeSentence(sentence,new String ("When" + " "+ sentenceNew3 +" " + sentence));
    	 }
       });
     return createPane(simpleDialogDesc + ":",
		      textFieldPane, 
		      showItButton);
  }

  public void actionPerformed(ActionEvent evt)
  {
    if (evt.getActionCommand().equals("Teach Open Mind")) {
      System.out.println("asdf2");
      {
      }
    }
  }
  private JPanel createPane(String description,
			    JPanel panel,
			    JButton showButton) {
        
      JPanel box = new JPanel();
        JLabel label = new JLabel(description);

        box.setLayout(new BoxLayout(box, BoxLayout.Y_AXIS));
        box.add(label);

	box.add(panel);
	JPanel pane = new JPanel();
        pane.setLayout(new BorderLayout());
        pane.add(box, BorderLayout.NORTH);
        pane.add(showButton, BorderLayout.SOUTH);
        return pane;
    }

    	    
  private JPanel createIconDialogBox() {
    
    final JTextField textField=new JTextField(sentence, 40);
    textField.addActionListener(this);
    JLabel textFieldLabel = new JLabel("Change the sentence as you see fit!");
    textFieldLabel.setLabelFor(textField);
      
    JPanel textFieldPane=new JPanel();
    textFieldPane.setLayout(new FlowLayout());
    textFieldPane.add(textFieldLabel);
    textFieldPane.add(textField);
      JButton showItButton = null;
    
    showItButton = new JButton("Teach Open Mind!");
    
     showItButton.addActionListener(new ActionListener() {
	 public void actionPerformed(ActionEvent e) {
	   final String sentenceNew=textField.getText();
	    if ((sentenceNew==null)||emptyString.equals(sentenceNew)){
	     JOptionPane.showMessageDialog(DialogDemo.this, "Please teach something new to Open Mind","error",
					   JOptionPane.ERROR_MESSAGE);
	   }
	   else fbe.storeSentence(sentence,sentenceNew);
    	 }
       });
     return createPane(simpleDialogDesc + ":",
		       textFieldPane, 
		       showItButton);
  }
  public void returnSentences() {
    
    
  }
  
	
  private JPanel createFeatureDialogBox() {
    final JTextField textField=new JTextField(15);
    JLabel textFieldLabel = new JLabel("If");
    textFieldLabel.setLabelFor(textField);
    JLabel textFieldLabel2=new JLabel(sentence);
    
    JPanel textFieldPane=new JPanel();
    textFieldPane.setLayout(new FlowLayout());
    textFieldPane.add(textFieldLabel);
    textFieldPane.add(textField);
    textFieldPane.add(textFieldLabel2);
    JButton showItButton = null;
    
    showItButton = new JButton("Teach Open Mind!");
   
     showItButton.addActionListener(new ActionListener() {
	 public void actionPerformed(ActionEvent e) {
	   final String sentenceNew2=textField.getText();
	   if ((sentenceNew2==null)||emptyString.equals(sentenceNew2)){
	     JOptionPane.showMessageDialog(DialogDemo.this, "Please teach something new to Open Mind","error",
					   JOptionPane.ERROR_MESSAGE);
	   }
	   else fbe.storeSentence(sentence,new String("If " +sentenceNew2+ " " + sentence));
	 }
       });
     return createPane(simpleDialogDesc + ":",
		       textFieldPane, 
		       showItButton);

  };
	    
  public static void main(String[] args) {
    JFrame frame = new JFrame("DialogDemo");
    
    Container contentPane = frame.getContentPane();
        contentPane.setLayout(new GridLayout(1,1));
        //contentPane.add(new DialogDemo(frame, 1, "asdf"));

        frame.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });

        frame.pack();
        frame.setVisible(true);
    }
}
