import java.util.*;
import java.io.*;
//import omcsnet.*; // caSe SenSitive

class FinalBE
{
    String fileName;
    LineNumberReader lnr;
    
    List sentenceList;
    int numSentences =0;

    BufferedWriter sout;
    String fileOutName;
    String hashOutName;

    HashMap sentenceStorage;
    

    public FinalBE()
    {
	fileName = "sentences.txt";
	fileOutName = "storage.txt";
	hashOutName = "hashstore.txt";
	sentenceList = new ArrayList();
	sentenceStorage = new HashMap();

	try {
	    lnr = new LineNumberReader(new FileReader(fileName));
	    //sout = new BufferedWriter(new FileWriter(fileOutName));
	    initializeSentenceList();
	    lnr.close();

	    //initialize the hash map
	    FileInputStream istream = new FileInputStream(hashOutName);
	    ObjectInputStream p = new ObjectInputStream(istream);
	    
	    Object obj = p.readObject();
	    if (obj != null)
		{
		    sentenceStorage = (HashMap) obj;
		}
	    else (sentenceStorage = new HashMap());
	    
	    
	    p.close();
	    istream.close();
	    

	}
	catch(Exception e) { System.out.println(e.toString());}
	System.out.println("size of initialized hash " + sentenceStorage.size());
    }


    /*
      initializes the list of sentences to be the sentences in sentences.txt
      and sets the variable numSentences to be the length of the file
    */

    public void initializeSentenceList() throws IOException
    {
	//keep track of the total number of sentences.
	int size = 0;
	
	String line = "begin";
        while (line != null)
		{
		    line = lnr.readLine();
		    size++;
		    sentenceList.add(line);
		    // System.out.println(i + "  " + line);
		}
	
	numSentences = size;
    }

    public String getRandomSentence()
    {
	double x = numSentences*Math.random();
	int y = (int) Math.floor(x);
	System.out.println("the sentence number we want is:  " + y);
	String str = (String) sentenceList.get(y);
	return str;
    }

    public void storeSentence(String currentSentence, String text)
    {
	if (sentenceStorage.containsKey(currentSentence) == true)
	    {
		List lst = (List) sentenceStorage.get(currentSentence);
		if (!(lst.contains(text)))
		    lst.add(text);
		sentenceStorage.put(currentSentence, lst);
	    }
	else 
	    {
		List lst = new ArrayList();
		lst.add(text);
		sentenceStorage.put(currentSentence, lst);
	    }
		
	try {
	    sout = new BufferedWriter(new FileWriter(fileOutName, true));
	    sout.write(text);
	    sout.write("\n");
	    sout.close();

	    FileOutputStream ostream = new FileOutputStream(hashOutName);
	    ObjectOutputStream p = new ObjectOutputStream(ostream);
	    
	    p.writeObject(sentenceStorage);
	    System.out.println("i am writing to the hash storage");
	    //p.close();
	    ostream.close();
	    
	}
	catch(Exception e) { System.out.println(e.toString()); }	


    }

    //can return an empty list.  =)
    public List getAssociatedSentences(String sentence)
    {
	if (sentenceStorage.containsKey(sentence) == true)
	    {
		List lst = (List) sentenceStorage.get(sentence);
		return lst;
	    }
	else 
	    {
		List lst = new ArrayList();
		lst.add("You are the first to teach OpenMind about the context of this sentence!");
		return lst;
	    }
    }
    
    //this procedure searches through the keys of the hash map to see if there are keys that contain
    //a substring "concept".  if so, then it will return the sentences associated with those keys in a list.
    //if there are not keys that contain this substring, then it will return a list of the string: 
    // "There are no contextual sentences for this concept.  Be the first to add one!"
    public List getConceptSentences(String concept)
    {
	Set keyset = sentenceStorage.keySet();
	List returnList = new ArrayList();
	
	for (Iterator iter = keyset.iterator(); iter.hasNext();)
	    {
		String key = (String) iter.next();
		
		if (key.indexOf(concept) != -1)
		    {
			List lst = (List) sentenceStorage.get(key);
			returnList.addAll(lst);
		    }
	    }
	if (returnList.size() == 0)
	    returnList.add("There are no contextual sentences for this concept.  Be the first to add one!");
	return returnList;
    }
    
	
    /*
    public static void main(String args[])
    {
	FinalBE fbe = new FinalBE();
	
	//System.out.println(fbe.sentenceList.get(1));
	//System.out.println(fbe.sentenceList.get(2));
	System.out.println(fbe.numSentences);
	
	String str = fbe.getRandomSentence();
	String str2 = fbe.getRandomSentence();

	String sub1 = str2.substring(1,10);

	System.out.println("sentence 1: " + str);
	System.out.println("sentence 2: " + str2);
	
	fbe.storeSentence(str, "the cat likes the dog");
	fbe.storeSentence(str, "the cat likes the dog");
	fbe.storeSentence(str, "the dog likes the cat");

	fbe.storeSentence(str2, "i am a cow");


	System.out.println("for the first one");
	int size = fbe.sentenceStorage.size();
	
	System.out.println(size);
	List lst = (List) fbe.sentenceStorage.get(str);
	System.out.println(lst);

	System.out.println("for the second one");
	FinalBE fbe2 = new FinalBE();
	size = fbe2.sentenceStorage.size();
	
	System.out.println(size);
	lst = (List) fbe2.sentenceStorage.get(str);
	System.out.println(lst);
	fbe2.storeSentence(str2, "i am not a cow");
	fbe2.storeSentence(str, "i like the cat");
	
	System.out.println("for the third one");
	FinalBE fbe3 = new FinalBE();
	size = fbe3.sentenceStorage.size();
	
	System.out.println(size);
	lst = (List) fbe3.sentenceStorage.get(str);
	System.out.println(lst);
	System.out.println("for first sentence: " + fbe3.getAssociatedSentences(str));
	System.out.println("for second sentence: " + fbe3.getAssociatedSentences(str2));
	System.out.println(fbe3.getAssociatedSentences("hello"));

	System.out.println("\n" + "\n");
	System.out.println("searching for concept: " + sub1 + "  " + fbe3.getConceptSentences(sub1));
	System.out.println(fbe3.getConceptSentences("masfdljsl"));
	
    }
    */

}
