//This will build the file of sentences used for the FinalBE backend and the
//rest of the application.
//This file requires Hugo's interface to run.  =)


//package omcsnet;

import java.util.*;
import java.io.*;
import omcsnet.*; // caSe SenSitive

class SentenceFileBuilder
{
    OMCSNetJava sm;
    BufferedWriter sout;
    List sentenceList;

    public SentenceFileBuilder()
    {
	sm = new OMCSNetJava();
	
	
	try 
	    {
		sout = new BufferedWriter(new FileWriter("sentences.txt"));
		writeSentencesToFile();
		sout.close();

	    }
	catch(Exception e)
	    { System.out.println(e.toString());}
	

    }


    public List getSentences(String node)
    {
	String str = sm.GetNode(node);
	StringTokenizer st = new StringTokenizer(str, "%");	
	
	String prevToken = "";
	List sentences = new ArrayList();
	while (st.hasMoreTokens() == true)
	    {
		String token = st.nextToken();
		if ((token.equals("bw")) || (token.equals("fw")))
		    sentences.add(prevToken);
		prevToken = token;
	    }

	return sentences;
    }
	

    public void writeSentencesToFile() throws IOException
    {
	String[] nodes = {"vacation", "adversary", "wedding", "wedding ceremony", "wedding chapel", "wedding dress", "wedding reception", "wedding ring", "wedding rings", "weekend", "weekend at beach", "entertainment", "entertainment and education", "entertainment and familiarity", "entertainment and leaving"};

	int numNodes = nodes.length;
	
	for (int k = 0; k<numNodes; k++)
	    {
		String node = (String) nodes[k];
		List sentences = this.getSentences(node);
		int size = sentences.size();
		//System.out.println(size);
		for (int i = 0; i<size; i++)
		    {
			String str = (String) sentences.get(i);
			sout.write(str);
			sout.write("\n");
			//System.out.println(sentences.get(i));
		    }
	    }
    }

    public void addSentencesFromNode(String node)
    {
	List lst = this.getSentences(node);
	
	int size = lst.size();
	try 
	    {
		BufferedWriter sentout = new BufferedWriter(new FileWriter("sentences.txt", true));
		for (int i=0; i<size; i++)
		    {
			sentout.write((String) lst.get(i));
			sentout.write("\n");
		    }
		sentout.close();
	    }
	catch(Exception e) { System.out.println(e.toString()); }
	
	
    }


    public static void main(String args[])
    {
	SentenceFileBuilder sfb = new SentenceFileBuilder();
	System.out.println("Done writing to file");
	sfb.addSentencesFromNode("person");
    }
    
}
